
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"

#include "initng_history.h"
#include "initng_active_status.h"
#include "initng_global.h"
#include "initng_toolbox.h"
#include <sys/types.h>                      /* time_t */
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>                          /* printf() */
#include <assert.h>

int history_records = 0;

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              /* this walks the db, and update the timings, if system clock changes *//*history_h **history_db = NULL; *//* a big list of pointers pointing to all known history structs */
void history_db_compensate_time(time_t skew)
{
    history_h *current = NULL;

    D_("history_db_compensate_time(%i);\n", (int) skew);

    while_history_db(current)
    {
        if (current->time)
            current->time += skew;
    }
}

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     /* this walks the db, and clears particular services *//*history_h **history_db = NULL; *//* a big list of pointers pointing to all known history structs */
void history_db_clear_service(active_h * service)
{
    history_h *current = NULL;

    D_("history_db_clear_service(%s);\n", service->name);

    while_history_db(current)
    {
        if (current->service == service)
        {
            current->service = NULL;
            current->name = i_strdup(service->name);
        }
    }
}

/* clear history */
void history_free_all(void)
{
    history_h *current, *safe = NULL;

    /* while there is a histry db */
    while_history_db_safe(current, safe)
    {
        /* free histry name */
        if (current->name)
            free(current->name);

        /* remove from history_db list */
        list_del(&current->list);

        /* free histroy entry */
        free(current);
    }
}

/* add values to history database */
void history_add_values(active_h * service)
{
    history_h *tmp_e = NULL;    /* temporary pointer to insert data and add to db */

    assert(service->name);

    D_("adding: %s.\n", service->name);

    /* allocate space for data */
    if (!(tmp_e = (history_h *) initng_calloc(1, sizeof(history_h))))
    {
        F_("history_add_values(): Out of memory.\n");
        return;
    }

    /* set data in struct */
    tmp_e->service = service;
    tmp_e->name = NULL;
    tmp_e->time = service->time_got_status;
    tmp_e->action = service->a_status;

    /* add struct */
    list_add(&tmp_e->list, &g.history_db.list);

    /* check lenght of history_db, and purge it on the end! */
    history_records++;

    if (history_records > HISTORY)
    {

        struct list_head *last = g.history_db.list.prev;
        history_h *entry = list_entry(last, history_h, list);

        if ((entry) && entry->name)
            free(entry->name);

        list_del(last);
        free(entry);
        history_records--;
    }

    /* leave */
    return;
}

/* returns the time in seconds, sense history entry name, switched to status from */
int time_been_from(active_h * service, e_a_status from)
{
    history_h *current = NULL;
    time_t from_t = 0;
    time_t time_now = time(0);

    assert(service);


    while_history_db(current)
    {
        if (current->service == service)
        {
            if (current->action == from)
                from_t = current->time;
        }
    }

    /* if now time is greater, more then last time (???) */

    if (from_t && time_now > from_t)
        return ((int) time_now - (int) from_t);
    else
        return (0);

}
