
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_HISTORY_H
#define INITNG_HISTORY_H
#include <sys/types.h>
#include "initng_active_status.h"
#include "initng_active_db.h"
#include "initng_list.h"

typedef struct history_s history_h;
struct history_s
{
    active_h *service;
    char *name;
    time_t time;
    e_a_status action;

    struct list_head list;
};

void history_free_all(void);
void history_db_compensate_time(time_t skew);
void history_db_clear_service(active_h * service);
void history_add_values(active_h * service);
int time_been_from(active_h * service, e_a_status from);

#define while_history_db(current) list_for_each_entry(current, &g.history_db.list, list)
#define while_history_db_prev(current) list_for_each_entry_prev(current, &g.history_db.list, list)
#define while_history_db_safe(current, safe) list_for_each_entry_safe(current, safe, &g.history_db.list, list)
#define while_history_db_safe_prev(current, safe) list_for_each_entry_prev_safe(current, safe, &g.history_db.list, list)


#endif
