
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERVICE_DATA_TYPES_H
#define SERVICE_DATA_TYPES_H

#include "initng_list.h"


typedef enum
{
    U_D_T,
    STRING,
    STRINGS,
    SET,
    UNSET,
    SCRIPT,
    INT
} e_dt;

typedef struct ss_entry
{
    const char *opt_name;
    e_dt opt_type;
    int str_len;

    struct list_head list;
} s_entry;

void initng_sdt_add(s_entry * ent);
void initng_sdt_del(s_entry * ent);
s_entry *initng_sdt_find(const char *string);
void initng_sdt_free_all(void);

#define while_option_db(current) list_for_each_entry(current, &g.option_db.list, list)
#define while_option_db_safe(current, safe) list_for_each_entry_safe(current, safe, &g.option_db.list, list)

#endif
