
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include "initng_static_data_id.h"
#include "initng_service_data_types.h"

/*
 * Here is where we define, the default options, and
 * relate to, by pointers
 * 
 * Description:
 * { "name_of_opt", TYPE_OF_OPT, STRING_LEN_OF("name_of_opt") }
 */
s_entry USE = { "use", STRINGS, 3 };
s_entry NEED = { "need", STRINGS, 4 };
s_entry RESPAWN = { "respawn", SET, 7 };
s_entry FROM_FILE = { "from_file", STRING, 9 };
s_entry ENV = { "env", STRINGS, 3 };
s_entry UP_WHEN_DONE = { "up_when_done", SET, 12 };
s_entry UP_WHEN_PID_SET = { "up_when_pid_set", SET, 15 };
s_entry UP_WHEN_STARTED = { "up_when_started", SET, 15 };
s_entry UP_WHEN_FAIL = { "up_when_fail", SET, 12 };

/*
 * add some default options, that is needed by core, and shud
 * be in option_db by default.
 * This function is called, from main(), initziation.
 */
void initng_sdt_add_defaults(void)
{
    initng_sdt_add(&USE);
    initng_sdt_add(&NEED);
    initng_sdt_add(&RESPAWN);
    initng_sdt_add(&FROM_FILE);
    initng_sdt_add(&ENV);
    initng_sdt_add(&UP_WHEN_DONE);
    initng_sdt_add(&UP_WHEN_PID_SET);
    initng_sdt_add(&UP_WHEN_STARTED);
    initng_sdt_add(&UP_WHEN_FAIL);
}
