
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef STRUCT_DATA_H
#define STRUCT_DATA_H

#include "initng_service_data_types.h"
#include "initng_list.h"

typedef struct ss_data s_data;

struct ss_data
{
    s_entry *type;
    union
    {
        char *s;
        char **l;
        int i;
    } t;

    struct list_head list;
};


char *d_get_string(s_entry * type, struct list_head *d);

/*char **d_get_stringlist(s_entry * type, s_data * d); */
int d_get_int(s_entry * type, struct list_head *d);
char *d_get_next_string(s_entry * type, struct list_head *d, char *last);
void d_set_another_string(s_entry * type, struct list_head *d, char *string);

#define d_set_string(type, d, string) d_set_string_real(type, d, string, __FILE__, __func__, __LINE__)
void d_set_string_real(s_entry * type, struct list_head *d, char *string,
                       const char *file, const char *func, int line);
/*void d_set_stringlist(s_entry * type, s_data * d, char **string); */
void d_set_int(s_entry * type, struct list_head *d, int value);
int d_count_type(s_entry * type, struct list_head *d);
int d_is(s_entry * type, struct list_head *d);
void d_set(s_entry * type, struct list_head *d);
void d_remove(s_entry * type, struct list_head *d);
void d_remove_all(struct list_head *d);

void d_copy_all(struct list_head *from, struct list_head *to);
#endif
